;To Do:
;* Fix DrawLevel routine        (Have to add Level and Moves)
;* End of level detection       (Scrapped old not working routine)

#include "usgard.h"             ;header file
 
Board    = TEXT_MEM             ;where the board is stored in text mem
Level    = TEXT_MEM+7           ;current level num

.org 0                          ;program origin
.db "LightsOut Alpha 1 by Jim Ruble",0

 ld     a,4                     ;go to rom page 4...
 out    (5),a                   ;for FIND_PIXEL ROM call
 call   CLEARLCD                ;clear screen

 ld     hl,&Board1
 call   &ChangeLevel            ;get current level

 ld     bc,0
 ld     e,128                   ;for position mask in Draw_XOR_Block
 ld     hl,Board                ;load board mem to hl
 call   &Draw_XOR_Block
Move:
 call   GET_KEY                 ;get key from keyboard
 cp     K_DOWN                  ;is it down key?
 jr     z,Down                  ;if yes goto Down
 cp     K_LEFT                  ;left?
 jr     z,Left                  ;goto Left
 cp     K_RIGHT                 ;right?
 jr     z,Right                 ;goto right
 cp     K_UP                    ;up?
 jr     z,Up                    ;goto Up
 cp     K_SECOND                ;2nd?
 jr     z,PlaceMove             ;goto PlaceMove
 cp     K_EXIT                  ;exit?
 ret    z                       ;if yes quit
 jr     Move                    ;loop back, get key, start over again...

Down:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 ld     a,c                     ;load y coord to a
 cp     56                      ;are we at the bottommost space?
 jr     nc,NoDown               ;if yes skip the increase and go to DS
 add    a,8                     ;otherwise add 8 to y coord (new col)
 ld     c,a                     ;y coord back to c
 inc    hl                      ;increase board byte (new col)
NoDown:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 jr     Move

Left:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 ld     a,b                     ;load x coord to a
 or     a                       ;compare a to 0
 jr     z,NoLeft                ;if leftmost space, go to DS
 sub    8                       ;otherwise subtract a space
 ld     b,a                     ;put x coord back to b
 rlc    e                       ;rotate position mask left
NoLeft:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 jr     Move

Right:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 ld     a,b                     ;load x coord to a
 cp     56                      ;are we at the rightmost space?
 jr     nc,NoRight              ;if yes skip the increase and go to DS
 add    a,8                     ;otherwise increase to new row
 ld     b,a                     ;x coord back to b
 rrc    e                       ;rotate position mask right
NoRight:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 jr     Move

Up:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 ld     a,c                     ;load y coord to a
 or     a                       ;are we at the topmost space?
 jr     z,NoUp                  ;if yes skip the increase and go to DS
 sub    8                       ;otherwise go up one column
 ld     c,a                     ;load y coord back to c
 dec    hl                      ;decrease board column pointer
NoUp:
 call   &Draw_XOR_Block         ;go to screen drawing routine
 jr     Move

PlaceMove:                      ;if 2nd was pressed...
 push   bc                      ;save bc
 push   de                      ;save de
 push   hl

 ld     a,b                     ;load x-cord into a
 or     a                       ;is it zero?
 jr     z,InvertCurrentPos      ;if yes, goto InvertCurrentPos

 ld     a,b                     ;get the x-cord from b
 sub    8                       ;decrease by 8 (get to left position)
 ld     b,a                     ;load it back to b

 rlc    e                       ;Memory:
 ld     a,(hl)                  ;  o
 xor    e                       ; xoo
 ld     (hl),a                  ;  o

 call   &Draw_Block             ;draw it

 ld     a,b                     ;get x-cord from b
 add    a,8                     ;increase by 8 (get back to center position)
 ld     b,a                     ;x-cord back to b

 rrc    e                       ;get memory back to center position

InvertCurrentPos:
 ld     a,(hl)                  ;get byte from board
 xor    e                       ;invert current position in memory
 ld     (hl),a                  ;load it back to hl

 call   &Draw_XOR_Block         ;back to origional block
 call   &Draw_Block             ;invert it
 call   &Draw_XOR_Block         ;back to XOR masked block

InvertRight:
 ld     a,b                     ;get x-cord to a
 cp     56                      ;is it 56?
 jr     z,InvertUp              ;if yes, go to InvertUp

 ld     a,b                     ;get x-cord to a
 add    a,8                     ;increase by 8 (get to right position)
 ld     b,a                     ;load x-cord back to b

 rrc    e                       ;rotate memory byte right
 ld     a,(hl)                  ;get byte from board
 xor    e                       ;invert it in memory
 ld     (hl),a                  ;load it back into hl

 call   &Draw_Block             ;invert block

 ld     a,b                     ;x-cord into a
 sub    8                       ;get center position
 ld     b,a                     ;x-cord back to b

 rlc    e                       ;rotate memory byte left

InvertUp:
 ld     a,c                     ;y-cord to a
 or     a                       ;zero?
 jr     z,InvertDown            ;if yes, go to InvertDown

 ld     a,c                     ;y-cord to a
 sub    8                       ;go to top position
 ld     c,a                     ;y-cord back to c

 dec    hl                      ;get to previous row
 ld     a,(hl)                  ;get byte from board
 xor    e                       ;invert top position
 ld     (hl),a                  ;load it back into hl

 call   &Draw_Block             ;invert block

 ld     a,c                     ;y-cord to a
 add    a,8                     ;go to center position
 ld     c,a                     ;y-cord back to c

 inc    hl                      ;next row down
                
InvertDown:
 ld     a,c                     ;y-cord to c
 cp     56                      ;is it 56?
 jr     z,InvertDone            ;if yes, go to InvertDone

 ld     a,c                     ;y-cord to a
 add    a,8                     ;increase it by 8 (get bottom position)
 ld     c,a                     ;y-cord back to c

 pop    de				  ;not sure why but these two lines are needed
 push   de				  ;try running without them and observe.
					  ;go fig huh?
 inc    hl                      ;hl points to next row
 ld     a,(hl)                  ;get byte from board
 xor    e                       ;invert bottom position
 ld     (hl),a                  ;load it back into hl

 call   &Draw_Block             ;invert block

InvertDone:
 pop    hl                      ;load hl
 pop    de                      ;load de
 pop    bc                      ;load bc
 jp     &Move                   ;go back to Move

Draw_XOR_Block:
 push   hl                      ;save hl
 ld     hl,&XOR_Block           ;load XOR block into hl
 call   &PutSprite              ;display it
 pop    hl                      ;load origional hl back
 ret                            ;return from subroutine

Draw_Block:
 push   hl                      ;save hl
 ld     hl,&Block               ;load block sprite into hl
 call   &PutSprite              ;display it
 pop    hl                      ;load origional hl back
 ret                            ;return from subroutine

PutSprite:                      ;puts sprite pointed to by hl at b,c
 push   bc                      ;sprite can be no larger than 8x8
 push   de                      ;much faster than NASR
 ld     a,63
 sub    c
 ld     c,a
 push   hl
 push   hl
 call   FIND_PIXEL
 ld     de,$FC00
 add    hl,de
 ex     de,hl
 pop    hl
 ld     b,(hl)
 inc    hl
 ld     c,(hl)
 inc    hl
 push   hl
 pop    ix
 ex     de,hl
PS_NewRow:
 push   bc
 ld     d,(ix)
 inc    ix
 push   af
 push   hl
PS_NewCol:
 rl     d
 ld     e,a
 jr     nc,PS_NoPixel
 xor    (hl)                    ;origionally 'or (hl)'
 ld     (hl),a
 jr     PS_NextPixel
PS_NoPixel:
 cpl
 and    (hl)
 ld     (hl),a
PS_NextPixel:
 ld     a,e
 rrca
 jr     nc,PS_SameByte
 inc    hl
PS_SameByte:
 djnz   PS_NewCol
 pop    hl
 pop    af
 ld     de,16
 add    hl,de
 pop    bc
 dec    c
 jr     nz,PS_NewRow
 pop hl
 pop de
 pop bc
 ret

ChangeLevel:                    ;Set up level loaded into hl
 push   hl
 push   bc

 ld     b,8
 ld     de,Board
LoadLoop:
 ld     a,(hl)
 ld     (de),a
 inc    hl
 inc    de
 djnz   LoadLoop

 ld     hl,Board                ;Loads current board state into hl (address)
 ld     bc,0                    ;x,y coords = 0,0 (top left)
 ld     d,128                   ;for masking (binary 10000000)
YLoop:
 ld     b,0                     ;new column
XLoop:
 ld     a,(hl)                  ;get byte
 and    d                       ;is the bit set?
 jr     z,DontDraw              ;if not, skip drawing routine
 push   hl                      ;stack: de,bc,hl,hl
 ld     hl,&Block               ;load block address into hl and
 call   &PutSprite              ;show it
 pop    hl                      ;stack: de,bc,hl
DontDraw:
 ld     a,b                     ;next X position
 add    a,8                     ;add 8 to x coord (next horizontal piece)
 ld     b,a                     ;move coord back to b
 rrc    d                       ;next bit
 jr     nc,XLoop                ;all 8 bits done?  If no, repeat x-loop
 inc    hl                      ;next byte
 ld     d,128                   ;mask for new column
 ld     a,c                     ;next Y position
 add    a,8                     ;add 8 to y coord (next vertical piece)
 ld     c,a                     ;move coord back to c
 cp     64                      ;Are all columns done?
 jr     c,YLoop                 ;if no (col# > 64) loop back to new column)
 inc    hl

 pop    hl                      ;get saved col
 pop    bc                      ;get saved position
 ret                            ;end sub

LevelText:
.db "Level:",0

MoveText:
.db "Moves:",0

Board1:
.db %11000011
.db %10000001
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %10000001
.db %11000011
.db 1,4
Board2:
.db %01000010
.db %11100111
.db %01000010
.db %00000000
.db %00000000
.db %01000010
.db %11100111
.db %01000010
.db 1,1

Block:
.db 8,8
.db %00000010
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %01111110
.db %11111110
.db %00000000

XOR_Block:
.db 8,8
.db %11111110
.db %11111110
.db %11111110
.db %11111110
.db %11111110
.db %11111110
.db %11111110
.db %00000000

.end
